#!/usr/bin/php
<?php
/*

# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
*/

$servername_s = "localhost";
$username_s = "<username>";
$password_s = "<password>";
$dbname_s = "p1";
$tabel_s="p1_maandverbruik";
$tabel_kolom_s="p1_timestamp";
$dbname_d = "p1";
$tabel_d="p1_kosten";
$tabel_kolom_d="p1_timestamp";


$jaar=date("Y");
// Debug parameter 0 = no debug 1 = debug
$ontluis=0;



function write_logfile($tekst){
//  $logfile = "/tmp/vul_aan.log";
  $logfile = "/tmp/bouw_kosten.log";
  $mylog = fopen($logfile, "a") or die("Unable to open logfile!: ". $logfile);
  fwrite($mylog, "<" . date("Y-m-d H:i:s") . "> ". $tekst ."\n");
  fclose($mylog);
}

write_logfile("Start program vul_aan table : ". $tabel_s);

// Create connection source
$conn_s = mysqli_connect($servername_s, $username_s, $password_s, $dbname_s);

// Check connection source 
if (!$conn_s) {
    write_logfile("Connection DB failed at host " . $servername_s . ". Error: " . mysqli_connect_error());
    die("Connection failed at host " . $servername_s . ". Error: " . mysqli_connect_error(). "\n");
}

if ($ontluis) {
  echo "Connected successfully at host " . $servername_s . "\n";
  echo "\n\n";
}
write_logfile("Connected successfully to database p1 at host " . $servername_s);

$sql="TRUNCATE TABLE  ". $tabel_d . ";";
if (mysqli_query($conn_s,$sql)){
  if ($ontluis) {
    echo "\nQuery truncate ". $sql ."\n\n";
    echo "Table ". $tabel_d ." deleted successfully\n";
  }
  write_logfile( "Table ". $tabel_d." deleted successfully. ");
} else {
  if ($ontluis) {
    echo "\nQuery truncate ". $sql ."\n\n";
    echo "Error deleting table: " . mysqli_error($conn_s). "\n";
  }
  write_logfile("Error deleting table: " . mysqli_error($conn_s));
}



$query='SELECT  X.Periode, '. 
          ' X.Verbruik_Laag ,    (X.Verbruik_Laag*X.Tarief_Laag) , ' .
					' X.Verbruik_Normaal , (X.Verbruik_Normaal*X.Tarief_Normaal) ,' .
          ' X.Retour_Laag ,      (X.Retour_Laag*X.Tarief_Laag*X.Retour_Factor_Laag) , ' .
					' X.Retour_Normaal ,   (X.Retour_Normaal*X.Tarief_Normaal*X.Retour_Factor_Normaal) ,' .
					' X.Verbruik_Gas ,     (X.Verbruik_Gas*X.Tarief_Gas) , ' .
					' (X.vermindering_energiebelasting + X.stroom_transport + X.gas_transport + X.vaste_leveringskosten) AS Vaste_kosten,  ' .
					'(X.Verbruik_Gas*X.correctie_gas),(X.Verbruik_Gas*X.Tarief_Gas*X.correctie_gas) ' .
          'FROM ( ' .
          'SELECT MV.MV_Maand AS Periode,Verbruik_Laag, Verbruik_Normaal,Retour_Laag, Retour_Normaal, Verbruik_Gas' .
          ',tarieven.Maand,tarieven.Tarief_Laag,tarieven.Tarief_Normaal,tarieven.Retour_Factor_Laag,tarieven.Retour_Factor_Normaal,tarieven.Tarief_Gas,tarieven.dagen '. 
		      ',tarieven.vermindering_energiebelasting,tarieven.stroom_transport,tarieven.gas_transport,tarieven.vaste_leveringskosten, tarieven.correctie_gas ' . 
          'FROM ( ' .
          'select date_format(Tijd,"%Y-%m-%d" ) AS MV_Maand, Verbruik_Laag, Verbruik_Normaal,Verbruik_Gas, Retour_laag, Retour_Normaal ' .
	        'FROM p1.p1_maandverbruik) MV ' .
          'INNER JOIN tarieven ON MV.MV_Maand=tarieven.Maand) X' ;
          
//-- INNER JOIN tarieven ON MV.MV_Maand=convert(tarieven.Maand,DATE)) X



if ($ontluis) {
  echo "\n\nQuery   = " . $query . "\n\n";
}

$result = mysqli_query($conn_s,$query);
if (mysqli_num_rows($result) > 0) {
  // output data of each row
  while($rij[] = mysqli_fetch_assoc($result)) ;
}





$len_rij=count($rij);
if ($ontluis) {
  echo "Aantal rijen  = " . $len_rij . "\n";
}

if ($ontluis) {
        for ($i=0; $i<$len_rij; $i++){
          if (isset($rij[$i])){
             print_r($rij[$i]);
          }
        }
}




$sql="SET SQL_MODE='ALLOW_INVALID_DATES'";
if (mysqli_query($conn_s,$sql)){
	  if ($ontluis) {
	    echo "SQL Mode successfully set\n";
	  }
	  write_logfile("SQL Mode successfully set");
	} else {
	  if ($ontluis) {
	    echo "Error SQL Mode set ". $sql . " ".  mysqli_error($conn_s) ."\n";
	  }
	  write_logfile("Error SQL Mode set ". $sql . " " . mysqli_error($conn_s) ); 
}
echo "Start inserting rows \n";
//Insert data in table.
$sql1="INSERT INTO ". $tabel_d . " VALUES (" ;
$sql2=");";

for ($i=0; $i<$len_rij; $i++){ 
  $subrij=$rij[$i];
  if (isset($rij[$i])){
      $regel = "";
        foreach ($subrij as $value)  {
          $regel =$regel . "," . "'" .  $value . "'";
        }
        $regel[0]=' ';
      	$sql=$sql1 . $regel . $sql2; 
  
  
    	if ($ontluis ) {
//     	  echo "-----------------------------------------------\n";
    	  echo $sql . "\n";
    	  write_logfile($sql);
      }
    
    	if (mysqli_query($conn_s,$sql)){
    	  if ($ontluis) {
    	    echo "Row  ". $sql ." successfully inserted\n"; 	  
      	  write_logfile("Row  ". $sql ." successfully inserted");
        }
    	} else {
    	  if ($ontluis) {
    	    echo "Error inserting row ". $sql . " ".  mysqli_error($conn_s) ."\n";
    	  }
    	  write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn_s) ); 
    	}
     echo '+';
 }
}

$aantal=$len_rij - 1;
echo "\n\nRows inserted : " . $aantal . "\n";
write_logfile("Rows inserted : " . $aantal);



mysqli_close($conn_s);
write_logfile("Connection to database p1 closed.");
write_logfile("End  program vul_aan : ". $tabel_d);
?>

