#!/bin/bash
# script for getting temperatuur from ESP8266
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above 
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility for any
# damage, accident or loss for using this script.

INBEST=/tmp/temperatuur
TMPBEST=/tmp/tempbest
TEMPSQL=/tmp/temp.sql
USERNAME="<username>"
PASSWORD="<password>"

rm ${INBEST} ${TMPBEST}  ${TEMPSQL}
wget http://192.168.2.154/data -O ${INBEST}

if [ -f ${INBEST} ]
then
        sed 's/{//' ${INBEST} | sed 's/}//' | sed 's/,/:/g' > ${TMPBEST}
        TEMPERATUUR=`cat ${TMPBEST} | cut -d: -f4`
        VOCHTIGHEID=`cat ${TMPBEST} | cut -d: -f2`
        TIJD=`cat ${TMPBEST} | cut -d: -f8-`
        echo  "Temp = ${TEMPERATUUR} "
        echo "Vocht = ${VOCHTIGHEID} "
        echo "Tijd  = ${TIJD} "
        echo "INSERT INTO p1.p1_temp SET Tijd = ${TIJD}, Temperatuur = ${TEMPERATUUR}, Vochtigheid = ${VOCHTIGHEID} ;" > ${TEMPSQL}
        mysql -u ${USERNAME} -p${PASSWORD} -h localhost < ${TEMPSQL}
fi

