#!/usr/bin/php 
<?php
/*
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
*/

// Start declaration ************************************************
$verbose=0;
//$Starttijd=strftime("%Y-%m-%d%%20%H:%M:%S", time()-432000);
$Eindtijd=strftime("%Y-%m-%d %H:%M:%S", time());
//tijdelijk
//$Starttijd="2019-02-09%2000:00:00";
$eklok="eklok.nl";

// Database 
$servername = "localhost";
$username = "<username>";
$password = "<password>";
$dbname = "p1";
$tabel="p1_kleur";

$sql1="INSERT INTO ". $tabel . " VALUES (" ;
$sql2=");";

// jSON URL which should be requested
$json_url = "https://". $eklok . "/api/pricedetail";
$timeout=15; 
//echo "Eindtijd is : " . $Eindtijd . "\n";

//echo "Starttijd is : " . $Starttijd . "\n";

// End declaration  *****************************************************

// Start function declarations ******************************************
function write_logfile($tekst){
  $logfile = "/tmp/bestetijd.log";
  $mylog = fopen($logfile, "a") or die("Unable to open logfile!: ". $logfile);
  fwrite($mylog, "<" . date("Y-m-d H:i:s") . "> ". $tekst ."\n");
  fclose($mylog);
}


// End function declarations ********************************************

write_logfile("Start program fill table : ". $tabel);

// Create connection mysql
$conn = mysqli_connect($servername, $username, $password, $dbname);

// Check connection
if (!$conn) {
    write_logfile("Connection DB failed: " . mysqli_connect_error());
    die("Connection failed: " . mysqli_connect_error(). "\n");
}

write_logfile("Connected successfully to database P1");

$datum_tijd=strftime("%Y-%m-%d %H:%M:%S ", time() );
$date = new DateTime($datum_tijd);
$date->add(new DateInterval('PT12H'));
$datum_morgen=$date->format('Y-m-d H:i:s');

if ($verbose){
    echo "Datum vandaag : " . $datum_tijd .  " Datum Morgen : " . $datum_morgen . "\n";
}


if ($verbose){
  write_logfile("Eindtijd : " . $Eindtijd );
  write_logfile("Url : ". $json_url );
}

$kleur_tabel=[];
for ($j=0; $j<133; $j++){
  $kleur_tabel[$j][0]=0;
  $kleur_tabel[$j][1]='#00ff00';
}  
// Initializing curl

//Open error file request
$f = fopen('/tmp/watermeter.err', 'w');

$ch = curl_init(  );

// Configuring curl options
$options = array(
CURLOPT_URL => $json_url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array('Content-type: application/json') ,
CURLOPT_CONNECTTIMEOUT => $timeout,
CURLOPT_SSL_VERIFYPEER => false,
CURLOPT_STDERR         => $f,
CURLOPT_VERBOSE        => $verbose
);

if ($verbose){
  write_logfile( "Set opions get values");
}

// Setting curl options
curl_setopt_array( $ch, $options );
if ($verbose){
  write_logfile( "Retrieve token");
}

// Getting results
$result = curl_exec($ch); // Getting jSON result string
if(curl_errno($ch))
{
	 write_logfile(  'Curl error: ' . curl_error($ch) . "\n");
	// close handle to release resources
	 curl_close($ch);	
}
else{ 
	$result_data=json_decode($result,true);
//  if ($verbose){
//    print_r($result_data[data][268]);
//  }
  $i=1;
  $zetnu=0;
  $meters=$result_data['data'];
//	print_r($meters); 
	foreach($meters as $index){
//		print_r($index);
		if (sizeof($index) > 1 ) {
       $best_tijd=str_replace("T",  " ", $index['date']);
       $best_tijd=str_replace(".000Z", "", $best_tijd);
       if ( $index['color'] == "#ff6c00" ){
         $index['color'] = "#ffae00";
 //        echo $best_tijd . " Kleur veranderd: ".  $index['color']. " \n";
       }
       if (( $best_tijd > $datum_tijd ) && ($best_tijd < $datum_morgen)){
         if ( $zetnu == 0 ){
           $nu_tijd = $best_tijd;
           $nu_kleur= $index['color'];
           $zetnu = 1 ;
         }
         $hbest_tijd=date_create($best_tijd);
         $uur=fmod(date_format($hbest_tijd,"H"),12);
         $minuut=round(date_format($hbest_tijd,"i")/5);
         $j=$uur*12 + $minuut;
//		     echo $i++ . " " . $index['date'] .  "  " .$best_tijd . " " .  $index['color'] . " ". $datum_tijd . " ". $uur ." " . $minuut . " " . $j . "\n";
         $kleur_tabel[$j][0]=$best_tijd;
         $kleur_tabel[$j][1]=$index['color'];
      }
		}
	}
  if ($verbose){ 
      $j=0;
      foreach($kleur_tabel as $kleur) {
          echo $j++ . " ". $kleur[0] . " " .  $kleur[1] . "\n";
      }
  } 
  
     $sql="TRUNCATE TABLE ". $tabel . ";";
    if (mysqli_query($conn,$sql)){
      if ($verbose) {
        echo "Table ". $tabel ." truncated successfully\n";
      }
      write_logfile( "Table ". $tabel ." truncated successfully. ");
    } else {
      if ($verbose) {
        echo "Error truncating table: " . mysqli_error($conn). "\n";
      }
      write_logfile("Error truncating table: " . mysqli_error($conn));
    }
   
  
  
    $j=1;
    $kleur_string="";
    foreach($kleur_tabel as $kleur) {
        if ($kleur[0] == 0 ) {
            $kleur[1] = $kleur_vorig;
            $kleur[0] = $datum_vorig;
        }
           
        $kleur_perc = $j*0.0069 ;
        $kleur_waarde = $kleur[1] ;
        $kleur_tijd   = $kleur[0];
        
        
       $sql_values = 'NULL'  ." , " . "'". $kleur_tijd . "'," . $kleur_perc . ",'" . $kleur_waarde . "'";
       
       $sql=$sql1 . $sql_values .$sql2;
       if ($verbose){
         echo $sql . "\n";
       }     
    
    // Write to database
       if (mysqli_query($conn,$sql)){
          write_logfile("Row  ". $sql ." successfully inserted");
       } else {
          write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn) ); 
       }
        $j++;    
        $kleur_vorig = $kleur[1];  
        $datum_vorig = $kleur[0];
   }
  
         
   $kleur_perc = 1 ;
   $kleur_waarde =  $kleur_tabel[143][1] ;
   $kleur_tijd   = $kleur_tabel[143][0];

   $sql_values = 'NULL'  ." , " . "'". $kleur_tijd . "'," . $kleur_perc . ",'" . $kleur_waarde . "'";
   
   $sql=$sql1 . $sql_values .$sql2;
   if ($verbose){
     echo $sql . "\n";
   }     

// Write to database
   if (mysqli_query($conn,$sql)){
      write_logfile("Row  ". $sql ." successfully inserted");
   } else {
      write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn) ); 
   }

// zet kleur nu in db

   $kleur_perc = 1 ;
   $kleur_waarde =  $nu_kleur ;
   $kleur_tijd   = $nu_tijd;

   $sql_values = 'NULL'  ." , " . "'". $kleur_tijd . "'," . $kleur_perc . ",'" . $kleur_waarde . "'";
   
   $sql=$sql1 . $sql_values .$sql2;
   if ($verbose){
     echo $sql . "\n";
   }     

// Write to database
   if (mysqli_query($conn,$sql)){
      write_logfile("Row  ". $sql ." successfully inserted");
   } else {
      write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn) ); 
   }

}


fclose($f);
mysqli_close($conn);
write_logfile("Connection to database P1 closed.");

write_logfile("End program fill table : ". $tabel);
?>


