#!/bin/bash
#set -x
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
USERNAME=<username>
PASSWORD=<password>
cd /home/peter/bin
/usr/bin/mysql -B -h localhost -D p1 -u ${USERNAME} -p${PASSWORD} -N  -e "source maandverbruik_water.sql" > /tmp/maandverbr_water.tmp
>/tmp/maandverbr_water.sql
CTIJD=`date '+%Y-%m-01 00:00'`
echo "SELECT  EXISTS ( select * from p1.p1_maandverbruik_water where TIJD LIKE \"${CTIJD}%\" ) AS BESTAATROW ; " > /tmp/maandverbr_watercheck.sql
CHEK=`mysql -h localhost -D p1 -u ${USERNAME} -p${PASSWORD} < /tmp/maandverbr_watercheck.sql | tail -1 `
echo "CHEK = ${CHEK}"
if [ ${CHEK} -eq 1 ]
then
        INSUP=UPDATE
else
        INSUP=INSERT
fi
DAG=`date '+%d'`
HTIJD=`date '+%Y-%m-01 00:00:'${DAG}`
echo "INSUP = ${INSUP} Dag = ${DAG} HTIJD = ${HTIJD}"

#tail -1 /tmp/maandverbr.tmp | tac | tail -3 | while read REGEL
tail -1 /tmp/maandverbr_water.tmp |  while read REGEL
#cat  /tmp/maandverbr_water.tmp |  while read REGEL
do
        CHRLEN=${#REGEL}
        if [ ${CHRLEN} -gt 5 ]
        then
          TIJD=`echo ${REGEL} |cut -f1-2 -d' ' | sed "s/00$/${DAG}/"`
          MIN_WATER=`echo ${REGEL} | cut -f3 -d' '`
          MAX_WATER=`echo ${REGEL} | cut -f4 -d' '`
          VERBRUIK_WATER=`echo ${REGEL} | cut -f5 -d' '`
          if [ ${CHEK} -eq 1 ]
          then
                 echo "UPDATE p1.p1_maandverbruik_water SET TIJD = \"${TIJD}\" , MIN_WATER = ${MIN_WATER}, MAX_WATER = ${MAX_WATER}, VERBRUIK_WATER = ${VERBRUIK_WATER}
 WHERE Tijd LIKE \"${CTIJD}%\" ;"  >> /tmp/maandverbr_water.sql
          else
                echo "INSERT INTO p1.p1_maandverbruik_water SET Tijd = \"${TIJD}\", MIN_WATER = ${MIN_WATER}, MAX_WATER = ${MAX_WATER}, VERBRUIK_WATER = ${VERBRUIK_WATER} ;"  >> /tmp/maandverbr_water.sql
          fi
        fi
done
mysql -h localhost -D p1 -u ${USERNAME} -p${PASSWORD} < /tmp/maandverbr_water.sql
cat /tmp/maandverbr_water.sql


