#!/usr/bin/php
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password

<?php
$servername = "localhost";
$username = "<username>";
$password = "<password>";
$dbname = "p1";
$jaar=date("Y");
// Is result from other program
$prog=array("mnd_solar.php");
$tabellen=array("solar_power");
$tabel_kolommen=array("Power");
//print_r($prog);
echo "argv[0] =". $argv[0] . " basename : ". basename($argv[0]) . "prog[0] : " . $prog[0] . "\n";
$ontluis=1;
for ($k = 0; $k < 5; $k++){
  if ($prog[$k] == basename($argv[0]) ) {
    $tabel=$tabellen[$k];
    $tabel_kolom=$tabel_kolommen[$k];
    $programma=$prog[$k];
    break; 
  }
}
if ($ontluis){
	echo "Executing  $programma \n"; 
}
// Debug parameter 0 = no debug 1 = debug
$ontluis=1;



function write_logfile($tekst){
//  $logfile = "/tmp/maandverbruik_laag.log";
  $logfile = "/tmp/". $GLOBALS['tabel']. ".log";
  $mylog = fopen($logfile, "a") or die("Unable to open logfile!: ". $logfile);
  fwrite($mylog, "<" . date("Y-m-d H:i:s") . "> ". $tekst ."\n");
  fclose($mylog);
}

write_logfile("Start program create table : ". $tabel);

// Create connection
$conn = mysqli_connect($servername, $username, $password, $dbname);

// Check connection
if (!$conn) {
    write_logfile("Connection DB failed: " . mysqli_connect_error());
    die("Connection failed: " . mysqli_connect_error(). "\n");
}

if ($ontluis) {
  echo "Connected successfully\n";
  echo "\n\n";
}
write_logfile("Connected successfully to database p1");

//get data from from p1_solaredgemonth and put in array.
$query = 'SELECT  DATE_FORMAT(Tijd,"%Y") AS Jaar, DATE_FORMAT(Tijd,"%m") AS Maand, '. $tabel_kolom . ' FROM p1_solaredgemonth ORDER BY MAAND, JAAR';
write_logfile("Get Data : ". $query);
$i = 0;
$result = mysqli_query($conn,$query);
if (mysqli_num_rows($result) > 0) {
  // output data of each row
  while($row[] = mysqli_fetch_assoc($result)) ;
}

$maandverbruik=$row;
$len_maandverbruik=count($maandverbruik);
if ($ontluis) {
	for ($i=0; $i<$len_maandverbruik; $i++){ 
//	  print_r($maandverbruik[$i]);
	  $rij=$maandverbruik[$i];
	  if (isset($maandverbruik[$i])){ 
	    $regel= "I = $i Jaar : ".  $rij['Jaar'] . " Maand : ".  $rij['Maand'] . " Waarde : " . $rij['Power'] ."\n";
	    echo $regel;
	  } 
	}
}

echo "\n\n";

// build create table string
// but first drop table if exists

$sql="DROP TABLE IF Exists ". $tabel . ";";
if (mysqli_query($conn,$sql)){
  if ($ontluis) {
    echo "Table ". $tabel ." deleted successfully\n";
  }
  write_logfile( "Table ". $tabel ." deleted successfully. ");
} else {
  if ($ontluis) {
    echo "Error deleting table: " . mysqli_error($conn). "\n";
  }
  write_logfile("Error deleting table: " . mysqli_error($conn));
}

$arr_jaar=array();
$data_string="";
$nr_of_jaar=2017;

for ($i=2017;$i<=$jaar;$i++){
	$data_string=$data_string .  " `Jaar_" . $i. "` decimal(10,3) DEFAULT NULL, ";
        $arr_jaar["$i"] = 0;
	$nr_of_jaar++;
}
if ($ontluis) {
	print_r($arr_jaar);
}

$sql = "CREATE TABLE " . $tabel."( ".
            "`maand_id` INT NOT NULL AUTO_INCREMENT, ".
            "`datum` DATETIME NOT NULL, ".
   	    $data_string  . 
            "PRIMARY KEY ( `maand_id` )); ";
write_logfile("Create Table : " . $sql);
if ($ontluis) {
  echo ("Create Table : " . $sql . "\n\n");
}

if (mysqli_query($conn,$sql)){
  if ($ontluis) {
    echo "Table ". $tabel ." created successfully\n";
  }
  write_logfile("Table ". $tabel ." created successfully");
} else {
  if ($ontluis) {
    echo "Error creating table: " . mysqli_error($conn) ."\n";
  }
  write_logfile("Error creating table: " . mysqli_error($conn) ); 
}

//Insert data in table.
$sql1="INSERT INTO ". $tabel . " VALUES (" ;
$sql2=");";
$rij_maand=01;
for ($i=0; $i<$len_maandverbruik; $i++){ 
//   print_r($maandverbruik[$i]);
     $rij=$maandverbruik[$i];
     if ( $rij_maand != $rij['Maand'] ) {
//	if ($ontluis) print_r($arr_jaar);

	$sql=$sql1 . $rij_maand . ',' . 'CONVERT("2021-' . $rij_maand .'-01 00:00:01", DATETIME)';
	for ($j=2017;$j < $nr_of_jaar ; $j++) {
	  $sql = $sql . ",".  $arr_jaar[$j] ;
	  $arr_jaar[$j] = 0;
	} 
	$sql = $sql . $sql2;

	if ($ontluis ) {
//     	  echo "-----------------------------------------------\n";
	  echo $sql . "\n";
	  write_logfile($sql);
        }
	$rij_maand=$rij['Maand'] ;

	if (mysqli_query($conn,$sql)){
	  if ($ontluis) {
	    echo "Row  ". $sql ." successfully inserted\n";
	  }
	  write_logfile("Row  ". $sql ." successfully inserted");
	} else {
	  if ($ontluis) {
	    echo "Error inserting row ". $sql . " ".  mysqli_error($conn) ."\n";
	  }
	  write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn) ); 
	}

     }
     $arr_jaar[$rij['Jaar']] =  $rij[$tabel_kolom] ;
}


mysqli_close($conn);

write_logfile("Connection to database p1 closed.");
write_logfile("End  program create table : ". $tabel);
?>

