#!/usr/bin/php 
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password, siteid and apikey


<?php
$verbose=1;
// 
// Database 
$servername = "localhost";
$username = "<username>";
$password = "password>";
$apikey="xxxxxxxxxxxx";
$siteid="XXXXX"
$dbname = "p1";
$tabel="p1_solaredgenow";

$rij_string="";
$select_last="Select Tijd from ". $tabel . " Order by Tijd DESC LIMIT 1";
$sql1="INSERT INTO ". $tabel . " VALUES (" ;
$sql2=");";

$Starttijd=strftime("%Y-%m-%d%%20%H:%M:%S", time()-3600);
$Eindtijd=strftime("%Y-%m-%d%%20%H:%M:%S", time());
//tijdelijk
//$Starttijd="2021-12-07%2015:00:00";
//$Eindtijd="2021-12-13%2015:30:00";
//Eind tijdelijk

function write_logfile($tekst){
//  $logfile = "/tmp/maandverbruik_laag.log";
  $logfile = "/tmp/solarnow.log";
  $mylog = fopen($logfile, "a") or die("Unable to open logfile!: ". $logfile);
  fwrite($mylog, "<" . date("Y-m-d H:i:s") . "> ". $tekst ."\n");
  fclose($mylog);
}
write_logfile("Start program fill table : ". $tabel);

// Create connection mysql
$conn = mysqli_connect($servername, $username, $password, $dbname);

// Check connection
if (!$conn) {
    write_logfile("Connection DB failed: " . mysqli_connect_error());
    die("Connection failed: " . mysqli_connect_error(). "\n");
}

write_logfile("Connected successfully to database p1");

write_logfile("Get Last Record  : ". $select_last);
$i = 0;
$result = mysqli_query($conn,$select_last);
if (mysqli_num_rows($result) > 0) {
  // output data of each row
  while($row[] = mysqli_fetch_assoc($result)) ;
//  print_r($row[0]);
  $lastdate=$row[0]['Tijd'];
}
else{
  $lastdate='2021-01-01 00:00:00';
}
 write_logfile("Last date from table is " . $lastdate); 



// jSON URL which should be requested
$json_url = "https://monitoringapi.solaredge.com/site/". $siteid ."/powerDetails.json?endTime=". $Eindtijd . "&startTime=" . $Starttijd . "&api_key=". $apikey;
$timeout=15; 
write_logfile("Starttijd is : " . $Starttijd .  "  Eindtijd is : " . $Eindtijd);
write_logfile("JSON URL = " . $json_url);

//Open error file request
$f = fopen('/tmp/solarnowrequest.txt', 'w');

// Initializing curl
$ch = curl_init(  );

// Configuring curl options
$options = array(
CURLOPT_URL => $json_url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array('Content-type: application/json') ,
CURLOPT_CONNECTTIMEOUT => $timeout,
CURLOPT_SSL_VERIFYPEER => false,
CURLOPT_STDERR         => $f,
CURLOPT_VERBOSE        => $verbose
);

fwrite($f, "Set opions get token\n");

// Setting curl options
curl_setopt_array( $ch, $options );

fwrite($f, "Retrieve get values\n");

// Getting results
$result = curl_exec($ch); // Getting jSON result string
if(curl_errno($ch))
{
  write_logfile( 'Curl error: ' . curl_error($ch));
	curl_close($ch);	
}
else{ 
	$result_data=json_decode($result,true);
// print_r($result_data);

/* -------------------------------------------- */
  $meters=$result_data['powerDetails']['meters']['0']['values'];
//  print_r($meters);
   $aantal =0; 
	foreach($meters as $index){
//		print_r($index);
		if (sizeof($index) > 1 ) {
       if ( $index['date'] > $lastdate ) {
		       $sql_values = "'". $index['date'] . "'" .  " , " . $index['value'] ;
             
             $sql=$sql1 . $sql_values .$sql2;
             echo $sql . "\n";
/* ------ */           
             if (mysqli_query($conn,$sql)){
	              write_logfile("Row  ". $sql ." successfully inserted");
                $aantal++;
	           } else {
                write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn) ); 
             }
/* ------- */                   
       } 
		}
	}	
  curl_close($ch);
/* ------------------------------------------ */
}
write_logfile("Number of rows inserted :  " . $aantal );
mysqli_close($conn);
write_logfile("Connection to database p1 closed.");

write_logfile("End program fill table : ". $tabel);
fclose($f);

?>


