#!/usr/bin/php 
<?php
/*
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.
#
# Change siteid en apikey
*/

$apikey="xxxxxxxxxxxx";
$siteid="XXXXX"
$verbose=0;
$Starttijd=strftime("%Y-%m-%d%%20%H:%M:%S", time()-3600);
$Eindtijd=strftime("%Y-%m-%d%%20%H:%M:%S", time());
//tijdelijk
//$Starttijd="2020-01-09%2000:00:00";


// jSON URL which should be requested
$json_url = "https://monitoringapi.solaredge.com/site/".$siteid ."/energyDetails.json?meters=PRODUCTION&timeUnit=MONTH&endTime=". $Eindtijd . "&startTime=" . $Starttijd . "&api_key=". $apikey;
$timeout=15; 
//echo "Eindtijd is : " . $Eindtijd . "\n";

//echo "Starttijd is : " . $Starttijd . "\n";

$logf=fopen("/var/tmp/se15.log", "w+"); 
$f = fopen('/var/tmp/request.txt', 'w');
//fwrite($f, "<h3>Initializing get token</h3>\n");
$datum_tijd=strftime("%d-%m-%Y %H:%M;%S ", time());
fwrite($logf,"Starttijd : " . $Starttijd . " ". "Eindtijd : " . $Eindtijd ."\n");
fwrite($logf,"Url : ". $json_url . "\n");
//echo "Url : ". $json_url . "\n";
// Initializing curl
$ch = curl_init(  );

// Configuring curl options
$options = array(
CURLOPT_URL => $json_url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array('Content-type: application/json') ,
CURLOPT_CONNECTTIMEOUT => $timeout,
CURLOPT_SSL_VERIFYPEER => false,
CURLOPT_STDERR         => $f,
CURLOPT_VERBOSE        => $verbose
);

//fwrite($f, "<h3>Set opions get token</h3>\n");
$datum_tijd=strftime("%d-%m-%Y %H:%M;%S ", time());
fwrite($logf,$datum_tijd .  "Set opions get values\n");

// Setting curl options
curl_setopt_array( $ch, $options );

fwrite($f, "<h3>Retrieve get values</h3>\n");
$datum_tijd=strftime("%d-%m-%Y %H:%M;%S ", time());
fwrite($logf,$datum_tijd .  "Retrieve token\n");

// Getting results
$result = curl_exec($ch); // Getting jSON result string
if(curl_errno($ch))
{
    fwrite($f,'Curl error: ' . curl_error($ch));
	$datum_tijd=strftime("%d-%m-%Y %H:%M;%S ", time());
	fwrite($logf,$datum_tijd .  'Curl error: ' . curl_error($ch) . "\n");
	// close handle to release resources
	curl_close($ch);	
}
else{ 
	$result_data=json_decode($result,true);
	$meters=$result_data['energyDetails']['meters']['0']['values'];
//	print_r($meters);
	foreach($meters as $index){
//		print_r($index);
		if (sizeof($index) > 1 ) {
		   echo $index['date'] .  " Power = " . $index['value'] . "\n";
		}
		else {
		   echo $index['date'] .  " Power = " . "0.00" . "\n";
		}
	}
	
}
fclose($f);
fclose($logf);
?>
