#!/usr/bin/php 
<?php
/*
# Author Peter Westerbeek 2024-11-22
# You can use this script freely but please don't remove the comment above
#
# Disclaimer: use at own risk. Peter Westerbeek will not accept responsibility 
# for any damage, accident or loss while using this script.

# Change username and password
*/

// Start declaration ************************************************
$verbose=0;
//$Starttijd=strftime("%Y-%m-%d%%20%H:%M:%S", time()-432000);
$Eindtijd=strftime("%Y-%m-%d %H:%M:%S", time());
//tijdelijk
//$Starttijd="2019-02-09%2000:00:00";
$waterhost="192.168.2.152";

// Database 
$servername = "localhost";
$username = "<username>";
$password = "<password>";
$dbname = "p1";
$tabel="p1_water";

$sql1="INSERT INTO ". $tabel . " VALUES (" ;
$sql2=");";

// jSON URL which should be requested
$json_url = "http://". $waterhost . "/api/v1/data";
$timeout=15; 
//echo "Eindtijd is : " . $Eindtijd . "\n";

//echo "Starttijd is : " . $Starttijd . "\n";

// End declaration  *****************************************************

// Start function declarations ******************************************
function write_logfile($tekst){
  $logfile = "/tmp/watermeter.log";
  $mylog = fopen($logfile, "a") or die("Unable to open logfile!: ". $logfile);
  fwrite($mylog, "<" . date("Y-m-d H:i:s") . "> ". $tekst ."\n");
  fclose($mylog);
}


// End function declarations ********************************************

write_logfile("Start program fill table : ". $tabel);

// Create connection mysql
$conn = mysqli_connect($servername, $username, $password, $dbname);

// Check connection
if (!$conn) {
    write_logfile("Connection DB failed: " . mysqli_connect_error());
    die("Connection failed: " . mysqli_connect_error(). "\n");
}

write_logfile("Connected successfully to database P1");

$datum_tijd=strftime("%d-%m-%Y %H:%M;%S ", time());
if ($verbose){
  write_logfile("Eindtijd : " . $Eindtijd );
  write_logfile("Url : ". $json_url );
}

// Initializing curl

//Open error file request
$f = fopen('/tmp/watermeter.err', 'w');

$ch = curl_init(  );

// Configuring curl options
$options = array(
CURLOPT_URL => $json_url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array('Content-type: application/json') ,
CURLOPT_CONNECTTIMEOUT => $timeout,
CURLOPT_SSL_VERIFYPEER => false,
CURLOPT_STDERR         => $f,
CURLOPT_VERBOSE        => $verbose
);

if ($verbose){
  write_logfile( "Set opions get values");
}

// Setting curl options
curl_setopt_array( $ch, $options );
if ($verbose){
  write_logfile( "Retrieve token");
}
// Getting results
$result = curl_exec($ch); // Getting jSON result string
if(curl_errno($ch))
{
	 write_logfile(  'Curl error: ' . curl_error($ch) . "\n");
	// close handle to release resources
	 curl_close($ch);	
}
else{ 
	$result_data=json_decode($result,true);
  if ($verbose){
    print_r($result_data);
  }
  if ($verbose){
    echo "Total Liter : ".  $result_data['total_liter_m3'] . "  Active Liter : " . $result_data['active_liter_lpm'] . "  Total Liter Offset : " .  $result_data['total_liter_offset_m3'] . "\n";
  }


   $sql_values = 'NULL'  ." , " . "'". $Eindtijd ."'". " , " . $result_data['total_liter_m3'] . " , " . $result_data['active_liter_lpm'] . " , "  . $result_data['total_liter_offset_m3'] ;
//   $sql_values = "'". $index['date'] . "'" .  " , " . $index['value'] ;
   
   $sql=$sql1 . $sql_values .$sql2;
   if ($verbose){
     echo $sql . "\n";
   }     

// Write to database
   if (mysqli_query($conn,$sql)){
      write_logfile("Row  ". $sql ." successfully inserted");
   } else {
      write_logfile("Error inserting row ". $sql . " " . mysqli_error($conn) ); 
   }
}


fclose($f);
mysqli_close($conn);
write_logfile("Connection to database P1 closed.");

write_logfile("End program fill table : ". $tabel);
?>


